| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
EM::Horizon3DGeometry Class Reference
EarthModel

3D HorizonGeometry More...

`#include <emhorizon3d.h>`

Inheritance diagram for EM::Horizon3DGeometry:
[legend]

## Public Member Functions
| Horizon3DGeometry (Surface &)
| ~Horizon3DGeometry ()
mDeprecatedObs SectionID | cloneSection (const SectionID &) override
EMObjectIterator * | createIterator (const TrcKeyZSampling *=0) const override
bool | enableChecks (bool yn) override
void | fillBinIDValueSet (BinIDValueSet &, Pos::Provider3D *prov=0) const
void | fillBinIDValueSet (const SectionID &, BinIDValueSet &bvs, Pos::Provider3D *prov=0) const
const Geometry::BinIDSurface * | geometryElement () const override
Geometry::BinIDSurface * | geometryElement () override
bool | getBoundingPolygon (const SectionID &, Pick::Set &ps) const
bool | getBoundingPolygon (Pick::Set &) const
int | getConnectedPos (const PosID &, TypeSet< PosID > *) const override
void | getDataPointSet (const SectionID &, DataPointSet &dps, float shift=0.0) const
void | getDataPointSet (DataPointSet &, float shift=0.0) const
PosID | getNeighbor (const PosID &, const RowCol &) const
PosID | getPosID (const TrcKey &) const override
TrcKey | getTrcKey (const PosID &) const override
bool | isAtEdge (const PosID &pid) const override
bool | isChecksEnabled () const override
bool | isFullResolution () const override
bool | isNodeOK (const PosID &) const override
RowCol | loadedStep () const
mDeprecatedObs bool | removeSection (const SectionID &, bool hist) override
const Geometry::BinIDSurface * | sectionGeometry (const SectionID &) const override
Geometry::BinIDSurface * | sectionGeometry (const SectionID &) override
void | setStep (const RowCol &step, const RowCol &loadedstep)
RowCol | step () const
Public Member Functions inherited from EM::HorizonGeometry
| ~HorizonGeometry ()
Public Member Functions inherited from EM::RowColSurfaceGeometry
| RowColSurfaceGeometry (Surface &)
virtual | ~RowColSurfaceGeometry ()
StepInterval< int > | colRange () const
StepInterval< int > | colRange (const SectionID &, int row) const
StepInterval< int > | colRange (int row) const
EMObjectIterator * | createIterator (const TrcKeyZSampling *=nullptr) const override
const Geometry::RowColSurface * | geometryElement () const override
Geometry::RowColSurface * | geometryElement () override
StepInterval< int > | rowRange () const
StepInterval< int > | rowRange (const SectionID &) const
const Geometry::RowColSurface * | sectionGeometry (const SectionID &) const override
Geometry::RowColSurface * | sectionGeometry (const SectionID &) override
Public Member Functions inherited from EM::SurfaceGeometry
virtual | ~SurfaceGeometry ()
mDeprecatedObs SectionID | addSection (const char *nm, bool addtohistory)
mDeprecatedObs SectionID | addSection (const char *nm, const SectionID &, bool addtohistory)
EMObjectIterator * | createIterator (const EM::SectionID &, const TrcKeyZSampling *t=0) const
virtual void | fillPar (IOPar &) const
virtual int | findPos (const Interval< float > &x, const Interval< float > &y, const Interval< float > &z, TypeSet< PosID > *) const
virtual mDeprecatedDef int | findPos (const SectionID &, const Interval< float > &x, const Interval< float > &y, const Interval< float > &z, TypeSet< PosID > *res) const
virtual int | findPos (const TrcKeyZSampling &, TypeSet< PosID > *) const
virtual void | getLinkedPos (const PosID &posid, TypeSet< PosID > &) const
mDeprecatedObs bool | hasSection (const SectionID &) const
bool | isChanged (int) const
virtual bool | isLoaded () const
virtual Executor * | loader (const SurfaceIODataSelection *=nullptr)
int | nrSections () const
virtual void | removeAll ()
void | resetChangedFlag ()
virtual Executor * | saver (const SurfaceIODataSelection *=nullptr, const MultiID *=nullptr)
mDeprecatedObs SectionID | sectionID (const char *) const
mDeprecatedObs SectionID | sectionID (int idx) const
mDeprecatedObs int | sectionIndex (const SectionID &) const
mDeprecatedObs const char * | sectionName (const SectionID &) const
mDeprecatedObs bool | setSectionName (const SectionID &, const char *, bool addtohistory)
virtual bool | usePar (const IOPar &)
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()

## Protected Member Functions
Geometry::BinIDSurface * | createGeometryElement () const override
Protected Member Functions inherited from EM::HorizonGeometry
| HorizonGeometry (Surface &)
Protected Member Functions inherited from EM::SurfaceGeometry
| SurfaceGeometry (Surface &)
mDeprecatedObs SectionID | addSectionInternal (Geometry::Element *, const char *nm, const SectionID &, bool addtohistory)
void | geomChangeCB (CallBacker *)

## Protected Attributes
bool | checksupport_
RowCol | loadedstep_
RowCol | step_
Protected Attributes inherited from EM::SurfaceGeometry
bool | changed_
ObjectSet< Geometry::Element > | sections_
Surface & | surface_

## Additional Inherited Members
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Detailed Description

3D HorizonGeometry

<>

## Constructor & Destructor Documentation

## ◆ Horizon3DGeometry()

EM::Horizon3DGeometry::Horizon3DGeometry | ( | Surface & |  | ) |

## ◆ ~Horizon3DGeometry()

EM::Horizon3DGeometry::~Horizon3DGeometry | ( |  | ) |

## Member Function Documentation

## ◆ cloneSection()

mDeprecatedObs SectionID EM::Horizon3DGeometry::cloneSection | ( | const SectionID & |  | ) |
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ createGeometryElement()

Geometry::BinIDSurface * EM::Horizon3DGeometry::createGeometryElement | ( |  | ) | const
| override protected virtual

Implements EM::SurfaceGeometry.

## ◆ createIterator()

EMObjectIterator * EM::Horizon3DGeometry::createIterator | ( | const TrcKeyZSampling * | = 0 | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ enableChecks()

bool EM::Horizon3DGeometry::enableChecks | ( | bool | yn | ) |
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ fillBinIDValueSet() [1/2]

void EM::Horizon3DGeometry::fillBinIDValueSet | ( | BinIDValueSet & | ,
|  | Pos::Provider3D * | prov = 0 ) const

## ◆ fillBinIDValueSet() [2/2]

void EM::Horizon3DGeometry::fillBinIDValueSet | ( | const SectionID & | ,
|  | BinIDValueSet & | bvs,
|  | Pos::Provider3D * | prov = 0 ) const
| inline

## ◆ geometryElement() [1/2]

const Geometry::BinIDSurface * EM::Horizon3DGeometry::geometryElement | ( |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ geometryElement() [2/2]

Geometry::BinIDSurface * EM::Horizon3DGeometry::geometryElement | ( |  | ) |
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ getBoundingPolygon() [1/2]

bool EM::Horizon3DGeometry::getBoundingPolygon | ( | const SectionID & | ,
|  | Pick::Set & | ps ) const
| inline

## ◆ getBoundingPolygon() [2/2]

bool EM::Horizon3DGeometry::getBoundingPolygon | ( | Pick::Set & |  | ) | const

## ◆ getConnectedPos()

int EM::Horizon3DGeometry::getConnectedPos | ( | const PosID & | posid,
|  | TypeSet< PosID > * | res ) const
| override virtual

Returns
  the number of connected pos.

Reimplemented from EM::SurfaceGeometry.

## ◆ getDataPointSet() [1/2]

void EM::Horizon3DGeometry::getDataPointSet | ( | const SectionID & | ,
|  | DataPointSet & | dps,
|  | float | shift = 0.0 ) const
| inline

## ◆ getDataPointSet() [2/2]

void EM::Horizon3DGeometry::getDataPointSet | ( | DataPointSet & | ,
|  | float | shift = 0.0 ) const

## ◆ getNeighbor()

PosID EM::Horizon3DGeometry::getNeighbor | ( | const PosID & | ,
|  | const RowCol & | ) const

## ◆ getPosID()

PosID EM::Horizon3DGeometry::getPosID | ( | const TrcKey & |  | ) | const
| override virtual

Implements EM::HorizonGeometry.

## ◆ getTrcKey()

TrcKey EM::Horizon3DGeometry::getTrcKey | ( | const PosID & |  | ) | const
| override virtual

Implements EM::HorizonGeometry.

## ◆ isAtEdge()

bool EM::Horizon3DGeometry::isAtEdge | ( | const PosID & | pid | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ isChecksEnabled()

bool EM::Horizon3DGeometry::isChecksEnabled | ( |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ isFullResolution()

bool EM::Horizon3DGeometry::isFullResolution | ( |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ isNodeOK()

bool EM::Horizon3DGeometry::isNodeOK | ( | const PosID & |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ loadedStep()

RowCol EM::Horizon3DGeometry::loadedStep | ( |  | ) | const

## ◆ removeSection()

mDeprecatedObs bool EM::Horizon3DGeometry::removeSection | ( | const SectionID & | ,
|  | bool | hist )
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ sectionGeometry() [1/2]

const Geometry::BinIDSurface * EM::Horizon3DGeometry::sectionGeometry | ( | const SectionID & |  | ) | const
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ sectionGeometry() [2/2]

Geometry::BinIDSurface * EM::Horizon3DGeometry::sectionGeometry | ( | const SectionID & |  | ) |
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ setStep()

void EM::Horizon3DGeometry::setStep | ( | const RowCol & | step,
|  | const RowCol & | loadedstep )

## ◆ step()

RowCol EM::Horizon3DGeometry::step | ( |  | ) | const

## Member Data Documentation

## ◆ checksupport_

bool EM::Horizon3DGeometry::checksupport_
| protected

## ◆ loadedstep_

RowCol EM::Horizon3DGeometry::loadedstep_
| protected

## ◆ step_

RowCol EM::Horizon3DGeometry::step_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025